package cz.cvut.ok.kapo.paa.batoh;

/**
 * Jedna vec v batohu.
 * @author karel
 *
 */
public class Item implements Comparable{
	/**
	 * Cena predmetu
	 */
	private int cost;
	/**
	 * Vaha predmetu
	 */
	private int weight;
	
	/**
	 * Konstruktor. Vytvori novy predmet s cenou 0 a vahou 0.
	 */
	public Item(){
		super();
		this.cost=0;
		this.weight=0;
	}
	
	/**
	 * Konstruktor, vytvori novy predmet se zadanou vahou a cenou.
	 * @param cost cena predmetu
	 * @param weight vaha predmetu
	 */
	public Item(int cost, int weight) {
		super();
		this.cost=cost;
		this.weight=weight;
	}

	/**
	 * @return Returns the cost.
	 */
	public int getCost() {
		return cost;
	}

	/**
	 * @param cost The cost to set.
	 */
	public void setCost(int cost) {
		this.cost = cost;
	}

	/**
	 * @return Returns the weight.
	 */
	public int getWeight() {
		return weight;
	}

	/**
	 * @param weight The weight to set.
	 */
	public void setWeight(int weight) {
		this.weight = weight;
	}

	/**
	 * Porovna instance (jejich vahu).
	 */
	public int compareTo(Object o){
		return getWeight() - ((Item)o).getWeight();
	}
	
	/**
	 * Pokud je vaha i cena stejna, pak jsou objekty stejne.
	 */
	@Override public boolean equals(Object o){
		return (getWeight() == ((Item)o).getWeight() && getCost() == ((Item)o).getCost());
	}
	
	/**
	 * @override
	 */
	@Override public String toString(){
		return " [weight="+getWeight()+" cost="+getCost()+"]";
	}
}
