package cz.cvut.ok.kapo.paa.batoh.engines.bch;

import cz.cvut.ok.kapo.paa.batoh.Item;

/**
 * Trida pouse zajistuje porovnavani podle ceny pro setrideni.
 * @author karel
 *
 */
public class BestCostHeuristicItem extends Item{
	
	/**
	 * vytvori prazdny objekt
	 */
	public BestCostHeuristicItem() {
		super();
	}
	
	/**
	 * Konstruktor, vytvori novy predmet se zadanou vahou a cenou.
	 * @param cost cena predmetu
	 * @param weight vaha predmetu
	 */
	public BestCostHeuristicItem(int cost, int weight) {
		super(cost, weight);
	}
	
	/**
	 * Konstruktor, vytvori novy predmet podle predlohy.
	 * @param cost cena predmetu
	 * @param weight vaha predmetu
	 */
	public BestCostHeuristicItem(Item item) {
		super(item.getCost(), item.getWeight());
	}
	
	/**
	 * Porovna instance (podle jejich ceny).
	 */
	@Override public int compareTo(Object o){
		return -((Item)o).getCost() + getCost();
	}
}
