package cz.cvut.ok.kapo.paa.batoh.engines.bf;

import java.util.ArrayList;
import java.util.Arrays;

import cz.cvut.ok.kapo.paa.batoh.Configuration;
import cz.cvut.ok.kapo.paa.batoh.Item;
import cz.cvut.ok.kapo.paa.batoh.engines.Engine;
import cz.cvut.ok.kapo.paa.utils.MyStack;

/**
 * Trida pro vypocet obsazeni batohu metodou hrube sily.
 * @author karel
 */
public class BrutalForceEngine extends Engine{
	protected Item [] items;	//serazene pole veci z batohu
	protected MyStack<Integer> st;
	
	/**
	 * Inicializuje objekt, setridi pole.
	 * @param conf konfigurace predmetu a batohu.
	 */
	public BrutalForceEngine(Configuration conf) {
		super();
		initialize(conf);
	}

	public BrutalForceEngine(){
		super();
	}
	
	/**
	 * Provede nastaveni objektu.
	 */
	@Override
	public void initialize(Configuration conf){
		super.initialize(conf);
		items = conf.getItems().toArray(new Item[0]);
		st = new MyStack<Integer>();
	}

	@Override protected void run(){
		int actualCost=0;
		int actualWeight=0;
		Arrays.sort(items);	//setridime vzestupne

		ArrayList<Item> best=new ArrayList<Item>();
		int bestCost=getCost(best);	//vynulujeme
		int idx=0;
		Item itm = items[idx];
		list.add(itm);	
		st.push(new Integer(idx));//vlozime inicialni prvek
		actualCost+=itm.getCost();
		actualWeight+=itm.getWeight();
		while (!list.isEmpty() || itm.compareTo(items[items.length-1])!=0){
			if (actualWeight>conf.getSize()){
				Item tmpit = list.remove(list.size()-1);
				idx = st.pop().intValue();
				actualCost -= tmpit.getCost();
				actualWeight -= tmpit.getWeight();
			}else {
				if (bestCost<actualCost){//pokud je aktualni cena lepsi
					bestCost=actualCost;
					best=new ArrayList<Item>(list);
				}
				idx++; //posuneme se na dalsi prvek
				if (idx >= items.length){	//pokud jsme vycerpali vsechny prvky
					if (st.isEmpty())//znamena, ze jsme dopocitali
						break;
					idx=st.pop().intValue();
					list.remove(list.size()-1);
					actualCost -= items[idx].getCost();
					actualWeight -= items[idx].getWeight();
				}else{//vlozime do batohu dalsi vec
					st.push(new Integer(idx));
					list.add(items[idx]);
					actualCost += items[idx].getCost();
					actualWeight += items[idx].getWeight();
				}
			}
		}
		
		for (int i = 0; i<best.size(); i++){	//naplnime reseni
			sol.addItem(best.get(i));
		}
	}

	@Override
	protected int getStatesCount() {
		return st.getPops();
	}
}
