/**
 * 
 */
package cz.cvut.ok.kapo.paa.batoh.engines.dp;

import cz.cvut.ok.kapo.paa.batoh.Item;

/**
 * Jeden prvek sloupce u dynamickeho programovani.
 * @author karel
 */
public class DPCell {
	/**	Odkaz na predchozi bunku v tabulce. Je tu kvuli tomu,
	 * ze vypocet probiha jen za pouziti 2 sloupcu, takze si musim pamatovat
	 * cestu zpet */
	private DPCell prev;
	/** Pokud jsem pri prechodu do teto bunky pridal predmet do batohu,
	 * pridam ho i do bunky, abych jasne vedel, ze tu je. Jinak je null.*/
	private Item itm;
	/** Vaha vsech predmetu do teto chvile danych do batohu*/
	private int weight;
	
	
	/**
	 * Konstruktor
	 * @param prev odkaz na predchozi bunku v tabulce
	 * @param item predmet v batohu, jinak null
	 * @param weight celkova vaha predmetu v batohu
	 */
	public DPCell(DPCell prev, Item item, int weight) {
		super();
		this.itm = item;
		this.prev = prev;
		this.weight = weight;
	}

	/**
	 * @return Returns the itm.
	 */
	public Item getItm() {
		return itm;
	}


	/**
	 * @return Returns the prev.
	 */
	public DPCell getPrev() {
		return prev;
	}


	/**
	 * @return Returns the weight.
	 */
	public int getWeight() {
		return weight;
	}
}
